<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice3 extends AbstractStructArrayBase
{
    /**
     * The ChildrenC
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $ChildrenC;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice3
     * @uses ArrayOfJPSOAP_OrderedPrice3::setChildrenC()
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenC
     */
    public function __construct(array $childrenC = array())
    {
        $this
            ->setChildrenC($childrenC);
    }
    /**
     * Get ChildrenC value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getChildrenC()
    {
        return $this->ChildrenC;
    }
    /**
     * This method is responsible for validating the values passed to the setChildrenC method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildrenC method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildrenCForArrayConstraintsFromSetChildrenC(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_OrderedPrice3ChildrenCItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPrice3ChildrenCItem instanceof \StructType\JPSOAP_OrderedPrice) {
                $invalidValues[] = is_object($arrayOfJPSOAP_OrderedPrice3ChildrenCItem) ? get_class($arrayOfJPSOAP_OrderedPrice3ChildrenCItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_OrderedPrice3ChildrenCItem), var_export($arrayOfJPSOAP_OrderedPrice3ChildrenCItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildrenC property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildrenC value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenC
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice3
     */
    public function setChildrenC(array $childrenC = array())
    {
        // validation for constraint: array
        if ('' !== ($childrenCArrayErrorMessage = self::validateChildrenCForArrayConstraintsFromSetChildrenC($childrenC))) {
            throw new \InvalidArgumentException($childrenCArrayErrorMessage, __LINE__);
        }
        $this->ChildrenC = $childrenC;
        return $this;
    }
    /**
     * Add item to ChildrenC value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice3
     */
    public function addToChildrenC(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildrenC property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildrenC[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildrenC
     */
    public function getAttributeName()
    {
        return 'ChildrenC';
    }
}
